package cn.tedu.shoot;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**  */
public class ShootGame extends JPanel {
	public static final int WIDTH = 400;  //ڵĿ
	public static final int HEIGHT = 654; //ڵĸ
	
	public static BufferedImage background; //ͼ
	public static BufferedImage start;		//ͼ
	public static BufferedImage pause;		//ͣͼ
	public static BufferedImage gameover;	//Ϸͼ
	public static BufferedImage airplane;	//л
	public static BufferedImage bee;		//۷
	public static BufferedImage bullet;		//ӵ
	public static BufferedImage hero0;		//Ӣۻ0
	public static BufferedImage hero1;		//Ӣۻ1
	static{ //ʼ̬ͼƬ
		try{
			background = ImageIO.read(ShootGame.class.getResource("background.png"));
			start = ImageIO.read(ShootGame.class.getResource("start.png"));
			pause = ImageIO.read(ShootGame.class.getResource("pause.png"));
			gameover = ImageIO.read(ShootGame.class.getResource("gameover.png"));
			airplane = ImageIO.read(ShootGame.class.getResource("airplane.png"));
			bee = ImageIO.read(ShootGame.class.getResource("bee.png"));
			bullet = ImageIO.read(ShootGame.class.getResource("bullet.png"));
			hero0 = ImageIO.read(ShootGame.class.getResource("hero0.png"));
			hero1 = ImageIO.read(ShootGame.class.getResource("hero1.png"));
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static final int START = 0;     //״̬
	public static final int RUNNING = 1;   //״̬
	public static final int PAUSE = 2;     //ͣ״̬
	public static final int GAME_OVER = 3; //Ϸ״̬
	private int state = START; //ǰ״̬(Ĭ״̬)
	
	private Hero hero = new Hero(); //1Ӣۻ
	private List<FlyingObject> flyings = new ArrayList<FlyingObject>(); //1ѵ
	private Bullet[] bullets = {}; //1ӵ
	
	/** дpaint()  g: */
	public void paint(Graphics g){
		g.drawImage(background,0,0,null); //ͼ
		paintHero(g); //Ӣۻ
		paintFlyingObjects(g); //(л+С۷)
		paintBullets(g); //ӵ
		paintScoreAndLife(g); //ֺͻ
		paintState(g); //״̬
	}
	/** Ӣۻ */
	public void paintHero(Graphics g){
		g.drawImage(hero.image,hero.x,hero.y,null); //Ӣۻ
	}
	/** (л+С۷) */
	public void paintFlyingObjects(Graphics g){
		for(FlyingObject f:flyings){ //(л+С۷)
			g.drawImage(f.image,f.x,f.y,null); //(л+С۷)
		}
	}
	/** ӵ */
	public void paintBullets(Graphics g){
		for(int i=0;i<bullets.length;i++){ //ӵ
			Bullet b = bullets[i]; //ȡÿһӵ
			g.drawImage(b.image,b.x,b.y,null); //ӵ
		}
	}
	/** ֺͻ */
	public void paintScoreAndLife(Graphics g){
		g.setColor(new Color(0xFF0000)); //ɫ()
		g.setFont(new Font(Font.SANS_SERIF,Font.BOLD,24)); //ʽ(:SANS_SERIF ʽ:BOLDӴ  ֺ:24)
		g.drawString("SCORE: "+score,10,25); //
		g.drawString("LIFE: "+hero.getLife(),10,45); //
	}
	/** ״̬ */
	public void paintState(Graphics g){
		switch(state){ //ݵǰ״̬ͬͼ
		case START: //״̬ʱͼ
			g.drawImage(start,0,0,null);
			break;
		case PAUSE: //ͣ״̬ʱͣͼ
			g.drawImage(pause,0,0,null);
			break;
		case GAME_OVER: //Ϸ״̬ʱϷͼ
			g.drawImage(gameover,0,0,null);
			break;
		}
	}
	
	/** ɵ(л+С۷) */
	public FlyingObject nextOne(){
		Random rand = new Random(); //
		int type = rand.nextInt(20); //019֮
		if(type<4){ //03ʱС۷
			return new Bee();
		}else{ //419ʱɵл
			return new Airplane();
		}
	}
	
	int flyIndex = 0; //볡
	/** (л+С۷)볡 */
	public void enterAction(){ //10һ
		flyIndex++; //ÿ101
		if(flyIndex%40==0){ //ÿ400(10*40)һ
			flyings.add(nextOne());//ȡ˶
		}
	}
	
	/** (л+С۷+ӵ+Ӣۻ)һ */
	public void stepAction(){ //10һ
		hero.step(); //Ӣۻһ
		for(FlyingObject f:flyings){ //е
			f.step(); //һ
		}
		for(int i=0;i<bullets.length;i++){ //ӵ
			bullets[i].step(); //ӵһ
		}
	}
	
	int shootIndex = 0; //
	/** ӵ볡(Ӣۻӵ) */
	public void shootAction(){ //10һ
		shootIndex++; //ÿ101
		if(shootIndex%30==0){ //ÿ300(30*10)һ
			Bullet[] bs = hero.shoot(); //ȡӢۻӵ
			bullets = Arrays.copyOf(bullets,bullets.length+bs.length); //(bsмԪؾ󼸸)
			System.arraycopy(bs,0,bullets,bullets.length-bs.length,bs.length); //׷
		}
	}
	
	/** ɾԽķ(л+С۷+ӵ) */
	public void outOfBoundsAction(){ //10һ
		int index = 0; //1)Խ± 2)Խ˸
		List<FlyingObject> flyingLives = new ArrayList<FlyingObject>(); //Խ
		for(FlyingObject f:flyings){ //е,ȡÿһ
			if(!f.outOfBounds()){ //Խ
				flyingLives.add(f); //Խ˶ӵԽ
				index++; //1)Խ±һ 2)Խ˸һ
			}
		}
		flyings = flyingLives;
		
		index = 0; //1)Խӵ± 2)Խӵ
		Bullet[] bulletLives = new Bullet[bullets.length]; //Խӵ
		for(int i=0;i<bullets.length;i++){ //ӵ
			Bullet b = bullets[i]; //ȡÿһӵ
			if(!b.outOfBounds()){ //Խ
				bulletLives[index] = b; //ԽӵӵԽӵ
				index++; //1)Խӵ±һ 2)Խӵһ
			}
		}
		bullets = Arrays.copyOf(bulletLives,index); //Խӵ鸴ƵbulletsУindexмbulletsĳȾΪ
		
	}
	
	int score = 0; //ҵ÷
	/** ӵ(л+С۷)ײ */
	public void bangAction(){ //10һ
		for(int i=0;i<bullets.length;i++){ //ӵ
			Bullet b = bullets[i]; //ȡÿһӵ
			Iterator<FlyingObject> it = flyings.iterator();
			while(it.hasNext()){ //е
				FlyingObject f = it.next();//ȡÿһ
				if(f.shootBy(b)){ //ײ
					if(f instanceof Enemy){ //ײΪ
						Enemy e = (Enemy)f; //򽫱ײǿתΪ
						score += e.getScore(); //ҵ÷
					}
					if(f instanceof Award){ //ײΪ
						Award a = (Award)f; //򽫱ײǿתΪ
						int type = a.getType(); //ȡ
						switch(type){
						case Award.DOUBLE_FIRE:
							hero.addDoubleFire();
							break;
						case Award.LIFE:
							hero.addLife();
							break;
						}
					}
					it.remove();	
				}
			}
		}
	}
	
	/** Ӣۻ(л+С۷)ײ */
	public void hitAction(){ //10һ
		Iterator<FlyingObject> it = flyings.iterator();
		while(it.hasNext()){ //е
			FlyingObject f = it.next();//ȡÿһ
			if(hero.hit(f)){ //ײ
				hero.subtractLife(); //Ӣۻ
				hero.clearDoubleFire(); //Ӣۻջֵ
				it.remove();
			}
		}
	}
	
	/** Ϸ */
	public void checkGameOverAction(){ //10һ
		if(hero.getLife()<=0){ //Ϸ
			state = GAME_OVER; //޸ĵǰ״̬ΪϷ״̬
		}
	}
	
	/** ִ */
	public void action(){
		//
		MouseAdapter l = new MouseAdapter(){
			/** дƶ¼ */
			public void mouseMoved(MouseEvent e){
				if(state==RUNNING){ //״̬ʱִ
					int x = e.getX(); //ȡx
					int y = e.getY(); //ȡy
					hero.moveTo(x, y); //Ӣۻ궯
				}
			}
			/** д¼ */
			public void mouseClicked(MouseEvent e){
				switch(state){ //ݵǰ״̬ͬĴ
				case START:        //״̬ʱ
					state=RUNNING; //޸Ϊ״̬
					break;
				case GAME_OVER:  //Ϸ״̬ʱ
					score = 0; //ֳ(ݹ)
					hero = new Hero();
					flyings.clear();
					bullets = new Bullet[0];
					state=START; //޸Ϊ״̬
					break;
				}
			}
			/** дƳ¼ */
			public void mouseExited(MouseEvent e){
				if(state==RUNNING){ //״̬ʱ
					state=PAUSE; //޸Ϊͣ״̬
				}
			}
			/** д¼ */
			public void mouseEntered(MouseEvent e){
				if(state==PAUSE){ //ͣ״̬ʱ
					state=RUNNING; //޸Ϊ״̬
				}
			}
		};
		this.addMouseListener(l); //¼
		this.addMouseMotionListener(l); //껬¼
		
		Timer timer = new Timer(); //ʱ
		int intervel = 10; //ʱ(ԺΪλ)
		timer.schedule(new TimerTask(){
			public void run(){ //ʱɵǸ(10һ)
				if(state==RUNNING){ //״̬ʱִ
					enterAction(); //(л+С۷)볡
					stepAction();  //(л+С۷+ӵ+Ӣۻ)һ
					shootAction(); //ӵ볡(Ӣۻӵ)
					outOfBoundsAction(); //ɾԽķ(л+С۷+ӵ)
					bangAction();  //ӵ(л+С۷)ײ
					hitAction();   //Ӣۻ(л+С۷)ײ
					checkGameOverAction(); //Ϸ
				}
				repaint();     //ػ(paint())
			}
		},intervel,intervel); //ʱճ
	}
	
	public static void main(String[] args) {
		JFrame frame = new JFrame("Fly"); //
		ShootGame game = new ShootGame(); //
		frame.add(game); //ӵ
		frame.setSize(WIDTH, HEIGHT); //ôڴС
		frame.setAlwaysOnTop(true); //
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); //ĬϹرղ(رմ˳)
		frame.setLocationRelativeTo(null); //ôھ
		frame.setVisible(true); //1)ôڿɼ  2)paint()
		
		game.action(); //ִ
	}
	
}














